<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;

/**
 * Class ZoznamPoctuKontrolPodlaDruhu
 *
 * @package Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects
 */
final class ZoznamPoctuKontrolPodlaDruhu extends ZoznamPoctuKontrolAbstract implements ZoznamPoctuKontrol
{
    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrol $pocetKontrol
     *
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolPodlaDruhu
     */
    public function add(PocetKontrol $pocetKontrol): self
    {
        $addNewRecord = true;

        if (!$pocetKontrol instanceof PocetKontrolPodlaDruhu) {
            throw new InvalidArgumentException(
                sprintf(
                    'Ocakava sa instancia triedy %s, vtupny atribut je instancie %s',
                    PocetKontrolPodlaDruhu::class,
                    get_class($pocetKontrol)
                )
            );
        }

        array_walk(
            $this->items,
            function (?PocetKontrolPodlaDruhu &$pocetKontrolPodlaDruhu, int $index) use ($pocetKontrol, &$addNewRecord) {
                if ($pocetKontrolPodlaDruhu->equalsDruh($pocetKontrol)) {
                    $pocetKontrolPodlaDruhu = $pocetKontrolPodlaDruhu->navysitPocet($pocetKontrol);
                    $addNewRecord = false;
                }
            }
        );

        if ($addNewRecord) {
            $this->items[] = $pocetKontrol;
        }

        return new self($this->items);
    }

    /**
     * @param array $udaje
     *
     * @return self
     */
    public static function createFromArray(array $udaje = []): self
    {
        $zoznam = new self();

        foreach ($udaje as $udaj) {
            $zoznam->add(
                new PocetKontrolPodlaDruhu(
                    DruhEmisnejKontrolyEnum::from(mb_strtoupper($udaj['druh'])),
                    (int)$udaj['pocet']
                )
            );
        }

        return $zoznam;
    }
}
